/*
Nadrew's useful functions library

This library compiles a few functions I created that make any things easier in DM


Please read the html reference for further information on how to use the procs.
*/


proc

	uf_caps(string)//this function forces the first letter of a string to be capitlized
		//useful for things like names
		return uppertext(copytext(string,1,2)) + copytext(string,2,length(string)+1)
		//returns the first letter of the string as a cap, and the rest as normal

	uf_ishost(mob/person)//this function checks to see if a person is hosting the game
		if(!ismob(person) || !person.client)//can only check client mobs
			return 0//stop if it is not a client
		else
			if(!person.client.address || person.client.address == world.address)
			//checks to see if the person's address is null, or if it matches the world's address
				return 1//is a host
			else
				return 0//is not a host

	uf_islist(variable)//checks to see if a variable is a list or not

		if(istype(variable,/list))//if the variable's type is a list
			return 1//return TRUE
		else
			return 0

	uf_isplayer(mob/P)//this is useful to check if a person is a human

		if(P.client)//if P has a client
			return 1//TRUE
		else
			return 0

	uf_isactive(mob/P,ticks)//this is useful to check if a person is active
		if(!ticks)
			ticks = 1
		if(P.client)//if P has a client
			if(P.client.inactivity/10 <= ticks*10)//if P's inactivity is less than the ticks times 10 (a bit more accurate using division, and multiplication)
				return 1//return TRUE

			else
				return 0


	uf_gameopen()//this is useful to check if a game is being hosted or not
		if(world.port)//if the world's port var is TRUE
			return 1//return TRUE
		else
			return 0

	uf_clients()//this is useful to return a list of all clients connected to a world
		var/list/clients[0]//create a list entitled "clients"
		for(var/mob/M in world)//loop over all mobs in the world
		//also please note: for(var/client/M in world) does NOT work in this case
			if(M.client)//if M is a client
				clients.Add(M)//add M to the clients list

		return clients//return the clients list

	uf_num2dir(number as num)//this is useful when converting numbers to the direction they go with (1 = NORTH, so forth)
		if(!isnum(number))//first, we need to make sure it's really a number
			return
		else
			switch(number)//to shorten the code a bit

				if(0) return "Center"

				if(1) return "North"//if number is 1, make the proc return "North"

				if(2) return "South"

				if(4) return "East"

				if(8) return "West"

				if(5) return "Northeast"

				if(6) return "Southeast"

				if(9) return "Northwest"

				if(10) return "Southwest"

				else return//if it doesn't match any of them, return nothing

	uf_forcehost(port)//this is useful if you want your world to be hosted by force.
		//first we check to make sure it can be hosted
		if(!world.OpenPort(port))//unable
			return "Failed to open port for hosting"//output an error message.

		else
			world.OpenPort(port)//open the game
/* The uf_disable host function is now legacy code due to a change in BYOND at version 338
	uf_disablehost(loop)
		while(loop)//if you enabled it to loop
			sleep(1)
			if(world.port)//if the game is hosted
				world.OpenPort("none")//close it

		if(world.port)//if not looping
			world.OpenPort("none")
*/

	uf_split(T,delimiter)//delimiter is the symbol you want to use to split the items
		//this proc allows you to split a text string into seperate parts based on the delimiter
		//and add each part to its own part of a list
		if(!T || !delimiter)//if there's no data
			return//stop
		var
			list/returnedlist[0]//this will be used to display the results
			dellen = lentext(delimiter)//the length of the delimiter
			checked = 1//this will be used to tell what was just checked
		while(1)//loop
			sleep(10)//delay to reduce lag
			if(findtext(T,delimiter))//if it finds the delimiter
				var
					found = findText(T,delimiter,checked,0)//the position of the next delimiter
					additiontext
				additiontext = copytext(T,checked,found)//the next item in between delimiters
				returnedlist.Add("[additiontext]")//add it
				checked = found + dellen //advance position
				if(returnedlist.len >= checked)//if all the text has been checked
					return returnedlist//return the list
			else
				return


